#segmentation fault

# First create the render master
vtkRenderMaster rm;

# Now create the RenderWindow, Renderer and both Actors
set renWin [rm MakeRenderWindow];
set ren1   [$renWin MakeRenderer];
set iren   [$renWin MakeRenderWindowInteractor];

# create a plane source and actor
vtkPlaneSource plane;
vtkPolyMapper  planeMapper;
planeMapper SetInput [plane GetOutput];
vtkActor planeActor;
planeActor SetMapper planeMapper;

vtkImageShortReader reader;
reader DebugOn
reader SwapBytesOn;
reader SetDimensions 256 256 26;
reader SetFilePrefix "/home/surgery/u4/cline/cardiac/tmp/gain";
reader SetPixelMask 0x7fff;
reader ReleaseDataFlagOff;

vtkImageGradient2D gradient;
gradient SetInput [reader GetOutput];

vtkImageNonMaximalSuppression2D suppress;
suppress SetInput [gradient GetOutput];

vtkLinkEdgels edgels;
edgels SetInput [suppress GetOutput];

vtkPolyMapper edgelMapper;
edgelMapper SetInput [edgels GetOutput];

vtkActor edgelActor;
edgelActor SetMapper edgelMapper;




vtkImageToStructuredPoints image;
image SetInput [suppress GetOutput];
image SetExtent 0 255 0 255 20 20;
image SetAxes 0 1 2 






# load in the texture map
#
vtkTexture atext;
atext SetInput [image GetOutput];
atext InterpolateOn;
planeActor SetTexture atext;

# Add the actors to the renderer, set the background and size
$ren1 AddActors edgelActor;
$ren1 SetBackground 0.1 0.2 0.4;
$renWin SetSize 500 500;

# render the image
$iren Initialize;
set cam1 [$ren1 GetActiveCamera];
$cam1 Elevation -30;
$cam1 Roll -20;
$renWin Render;

#$renWin SetFilename "TPlane.tcl.ppm";
#$renWin SaveImageAsPPM;

# prevent the tk window from showing up then start the event loop
wm withdraw .





